const wk = require('./worker');
const cluster = require('cluster');
if (cluster.isMaster) {
    /* 多少个cpu启动多少个子进程 */
    for (let i = 0; i < require('os').cpus().length; i++) {
        wk(cluster.fork());
    }
    /* 如果有线程退出了，我们重启一个 */
    cluster.on('exit', () => {
        console.log('如果有线程退出了，我们重启一个');
        wk(cluster.fork())
    })
} else {
    /* 如果是子进程就去加载启动文件 */
    require('./child.js')
    /* 心跳回应 */
    process.on('message', (msg) => {
        msg === 'ping' && process.send('pong')
    })
    process.on('uncaughtException', (err) => {
        console.error('触发uncaughtException')
        /* 进程错误上报 */
        /* 如果程序内存大于xxxm了让其退出 */
        // console.log(process.memoryUsage().rss);
        if (process.memoryUsage().rss > 734003200) {
            console.log('大于700m了，退出程序吧');
            process.exit(1)
        }
        /* 退出程序 */
        process.exit(1)
    })
}